<!DOCTYPE html>
<html>

<head>
	<meta charset="UTF-8">
	<title> Lesson 4 :: Task 2 </title>

	<link rel="stylesheet" href="css/normalize.css" />
	<link rel="stylesheet" href="css/style.css" />
</head>

<body>
	<div class="Templating">
		<form>
			<input type="range" id="width_input" min="10" max="500" step="10" />
			<input type="range" id="height_input" min="10" max="500" step="10" />
			<input type="range" id="border_input" min="10" max="500" step="10" />
			<input type="range" id="padding_input" min="10" max="500" step="10" />
			<input type="color" id="color_input" min="10" max="500" step="10" />
		</form>

		<div class="TemplatingResult">
			<div id="result" class="result"></div>
		</div>

		<div id="popup" class="popup">
			<div class="circle"></div>
			<div class="circle"></div>
			<div class="circle"></div>
			<div class="circle"></div>
			<div class="circle"></div>
			<div class="circle"></div>
			<div class="circle"></div>
		</div>


	</div>
	<script>
		/*
			Задание 2.
	
			Сделать шиблонизатор элемента result по:
			- Ширине input type=range
			- Высоте input type=range
			- Скругление углов input type=range
			- Padding input type=range
			- Цвету  input type=color
	
			Список CSS свойств: https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Properties_Reference
	
	
			Для выбора цвета необходимо сделать вот такой интерфейс:
			https://s3.envato.com/files/230412754/screenshots/1.png
	
			При клике на color_input стандартный инпут цвета не должен появлятся, а должно открыться окно 
			как на макете выше. 
			Дальше по клику на круг с цветом, должен изменится цвет блока result, а также цвет внутри 
			самого элемента input.
	
			Для рандомайза цвета, можно использовать функцию рандома цвета из первых занятий.
	
		*/

		document.addEventListener('DOMContentLoaded', function () {
			const result = document.getElementById("result")
			const InputWidth = document.getElementById('width_input');

			InputWidth.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.width = event.target.value + 'px';
			});

			const InputHeight = document.getElementById('height_input');

			InputHeight.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.height = event.target.value + 'px';
			});

			const InputBorder = document.getElementById('border_input');

			InputBorder.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.borderRadius = event.target.value / 10 - 1 + 'px';
			});
			const InputPadding = document.getElementById('padding_input');

			InputPadding.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.padding = event.target.value + 'px';
			});

			let popup = document.getElementById("popup")

			const InputColor = document.getElementById('color_input');			
			InputColor.addEventListener('click', function (event) {
				event.preventDefault()
				setUpRandomColors()
				showPopup()
				console.log(event.target.value);
				result.style.padding = event.target.value + 'px';
			});


		function showPopup() {
			popup.classList.add("show")
		}
		function setUpRandomColors() {
			console.log(popup)
			popup.querySelectorAll(".circle").forEach((circle) => {
				console.log(circle)
				circle.style.backgroundColor = getRandomColor()
				circle.addEventListener("click", choseColor)
			});
		}
		function choseColor(e) {
			console.log(e.target.style.backgroundColor)
			let color = e.target.style.backgroundColor
			result.style.backgroundColor = color;
			InputColor.value = rgb2hex(color)
			popup.classList.remove("show")
		}
		function getRandomIntInclusive(min, max) {
			min = Math.ceil(min);
			max = Math.floor(max);
			return Math.floor(Math.random() * (max - min + 1)) + min;
		}
		function getRandomColor() {
			const min = 0;
			const max = 255;

			const r = getRandomIntInclusive(min, max);
			const g = getRandomIntInclusive(min, max);
			const b = getRandomIntInclusive(min, max);

			const rgbString = 'rgb(' + r + ', ' + g + ', ' + b + ')';
			return rgbString;
		}

		
		let hexDigits = new Array
        ("0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"); 

		//Function to convert rgb color to hex format
		function rgb2hex(rgb) {
		rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
		return "#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);
		}

		function hex(x) {
		return isNaN(x) ? "00" : hexDigits[(x - x % 16) / 16] + hexDigits[x % 16];
		}

	});

	</script>
</body>

</html>